#include "xparameters.h"
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "xuartlite_l.h"
#include "xsysace.h"

#define TRUE 1
#define FALSE 0
#define printf xil_printf

#define MEM_BASE_ADDR 0x80200000
#define MEM_TOP_ADDR  0x803FFFFF

Xuint16* sound = (Xuint16*)MEM_BASE_ADDR;
XSysAce sysAce;

int main (void) 
{
    int i;

    XSysAce_Initialize( &sysAce, XPAR_OPB_SYSACE_0_DEVICE_ID ); 
    XSysAce_ResetCF( &sysAce );
    while( !XSysAce_IsCFReady( &sysAce ) );
    XSysAce_Lock( &sysAce, XTRUE);

    sound = (Xuint16*)MEM_BASE_ADDR;
    
    for( i=0; i < 128; i++ )
    {
        *sound = i;
        sound++;
    }
    
    /* Load from memory to CF */
    XSysAce_SectorWrite( &sysAce, 0, 1, (Xuint8*)MEM_BASE_ADDR );
    
    /* Clear memory */
    sound = (Xuint16*)MEM_BASE_ADDR;
    for( i=0; i < 128; i++ )
    {
        *sound = 0;
        sound++;
    }

    sound = (Xuint16*)MEM_BASE_ADDR;
    
    /* Load from CF to memory */
    XSysAce_SectorRead( &sysAce, 0, 1, (Xuint8*)MEM_BASE_ADDR );
}
