/////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2004 Xilinx, Inc.  All rights reserved.
//
// Xilinx, Inc.
//
// XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
// COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
// ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
// STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION
// IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
// FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION.  
// XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
// THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
// ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
// FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
// AND FITNESS FOR A PARTICULAR PURPOSE.
// 
////////////////////////////////////////////////////////////////////////////////

#include "sysace.h"
#include "xparameters.h"
#include "xsysace_l.h"
#include "xsysace.h"
#include "xstatus.h"
#include "xbasic_types.h"
#include "xio.h"
static Xuint32 sysace_base_addr = 0;

/***** initalize system ace for  reading and writing  *****/
int init_ace()
{
  XSysAce Ace;
  XStatus Result;
  XStatus  status_init; 

  /* This code assumes only one systemace interface in the build and its Device ID is 0*/
  status_init = XSysAce_Initialize(&Ace, 0);
  sysace_base_addr = Ace.BaseAddress;
  while ((Result = XSysAce_Lock(&Ace, XFALSE)) != XST_SUCCESS)
    ;
  XSysAce_RegWrite32(sysace_base_addr + XSA_CR_OFFSET, 
                     XSA_CR_FORCECFGMODE_MASK);

  return (int) (status_init);
}

int read_sector(UINT32 sector, BYTE *pSectorBuffer)
{
  return XSysAce_ReadSector(sysace_base_addr, 
                            sector, pSectorBuffer);
}

int write_sector(UINT32 sector, BYTE *pSectorBuffer)
{
  return XSysAce_WriteSector(sysace_base_addr, 
                             sector, pSectorBuffer);
}
