library ieee; 
use ieee.std_logic_1164.all; 
use ieee.std_logic_unsigned.all; 
entity raminfr is 
  generic (
        C_DWIDTH : integer := 32;
        C_AWIDTH : integer := 16
  );
  port ( 
        clk  : in std_logic; 
        we   : in std_logic; 
        a    : in std_logic_vector(C_AWIDTH-1 downto 0); 
        dpra : in std_logic_vector(C_AWIDTH-1 downto 0); 
        di   : in std_logic_vector(C_DWIDTH-1 downto 0); 
        spo  : out std_logic_vector(C_DWIDTH-1 downto 0); 
        dpo  : out std_logic_vector(C_DWIDTH-1 downto 0) 
  ); 
end raminfr; 

architecture syn of raminfr is 
  type ram_type is array ((2**C_AWIDTH)-1 downto 0) of std_logic_vector ((C_DWIDTH-1) downto 0); 
  signal ram_mem : ram_type; 
  signal read_a : std_logic_vector(C_AWIDTH-1 downto 0); 
  signal read_dpra : std_logic_vector(C_AWIDTH-1 downto 0); 
begin 
  process (clk) 
    begin 
      if (clk'event and clk = '1') then 
          if (we = '1') then 
              ram_mem(conv_integer(a)) <= di; 
          end if; 
	  read_a <= a; 
	  read_dpra <= dpra; 
      end if; 
  end process; 
  spo <= ram_mem(conv_integer(read_a)); 
  dpo <= ram_mem(conv_integer(read_dpra)); 
end syn; 
