library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library unisim;
use unisim.vcomponents.all;

ENTITY my_fsl IS
	generic (
    	C_DWIDTH      : integer := 32
  	);
    Port (
	 	-- Global signals
      CLK : in std_logic;           -- System clock
      RESET : in std_logic;             -- System reset

		-- Slave FSL Signals
		FSL_S_Clk     : out std_logic;
		FSL_S_Read    : out std_logic;
		FSL_S_Data    : in  std_logic_vector(0 to C_DWIDTH-1);
		FSL_S_Control : in  std_logic;
		FSL_S_Exists  : in  std_logic;

		-- Master FSL Signals
		FSL_M_Clk     : out std_logic;
		FSL_M_Write   : out std_logic;
		FSL_M_Data    : out std_logic_vector(0 to C_DWIDTH-1);
		FSL_M_Control : out std_logic;
		FSL_M_Full    : in  std_logic
	);
END my_fsl;

ARCHITECTURE behavioral OF my_fsl IS

BEGIN

  read_data_fsl: process (CLK, FSL_S_Exists)
  begin
    if CLK'event and CLK = '1' then
      if FSL_S_Exists = '1' then
        FSL_S_Read <= '1';
        FSL_M_Data <= FSL_S_Data + '1';
        FSL_M_Write <= '1';
      else
        FSL_M_Write <='0';
        FSL_S_Read <= '0';
      end if;
    end if;
  end process;  

END behavioral;
