-- W:\ECE532\FIR_SIM
-- VHDL Test Bench created by
-- HDL Bencher 6.1i
-- Sun Mar 13 15:20:09 2005
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY toplevel_tb IS
END toplevel_tb;

ARCHITECTURE testbench_arch OF toplevel_tb IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT toplevel
		GENERIC (
			C_EXT_RESET_HIGH : INTEGER;
			C_ASYNC_CLKS : INTEGER;
			C_IMPL_STYLE : INTEGER;
			C_USE_CONTROL : INTEGER;
			C_FSL_DWIDTH : INTEGER;
			C_FSL_DEPTH : INTEGER
		);
		PORT (
			FSL_M_DATA : In  std_logic_vector (15 DOWNTO 0);
			FSL_M_CONTROL : In  std_logic;
			FSL_M_WRITE : In  std_logic;
			FSL_M_FULL : Out  std_logic;
			FSL_S_DATA : Out  std_logic_vector (31 DOWNTO 0);
			FSL_S_CONTROL : Out  std_logic;
			FSL_S_READ : In  std_logic;
			FSL_S_EXISTS : Out  std_logic;
			SYS_CLK : In  std_logic;
			SYS_RESET : In  std_logic
		);
	END COMPONENT;

	SIGNAL FSL_M_DATA : std_logic_vector (15 DOWNTO 0);
	SIGNAL FSL_M_CONTROL : std_logic;
	SIGNAL FSL_M_WRITE : std_logic;
	SIGNAL FSL_M_FULL : std_logic;
	SIGNAL FSL_S_DATA : std_logic_vector (31 DOWNTO 0);
	SIGNAL FSL_S_CONTROL : std_logic;
	SIGNAL FSL_S_READ : std_logic;
	SIGNAL FSL_S_EXISTS : std_logic;
	SIGNAL SYS_CLK : std_logic;
	SIGNAL SYS_RESET : std_logic;

BEGIN
	UUT : toplevel
	GENERIC MAP (
		C_EXT_RESET_HIGH => 1,
		C_ASYNC_CLKS => 0,
		C_IMPL_STYLE => 0,
		C_USE_CONTROL => 1,
		C_FSL_DWIDTH => 16,
		C_FSL_DEPTH => 16
	)
	PORT MAP (
		FSL_M_DATA => FSL_M_DATA,
		FSL_M_CONTROL => FSL_M_CONTROL,
		FSL_M_WRITE => FSL_M_WRITE,
		FSL_M_FULL => FSL_M_FULL,
		FSL_S_DATA => FSL_S_DATA,
		FSL_S_CONTROL => FSL_S_CONTROL,
		FSL_S_READ => FSL_S_READ,
		FSL_S_EXISTS => FSL_S_EXISTS,
		SYS_CLK => SYS_CLK,
		SYS_RESET => SYS_RESET
	);

	PROCESS -- clock process for SYS_CLK,
	BEGIN
		CLOCK_LOOP : LOOP
		SYS_CLK <= transport '0';
		WAIT FOR 10 ns;
		SYS_CLK <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		SYS_CLK <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS   -- Process for SYS_CLK
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_FSL_M_FULL(
			next_FSL_M_FULL : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_M_FULL /= next_FSL_M_FULL) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_M_FULL="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_M_FULL);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_M_FULL);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_FSL_S_DATA(
			next_FSL_S_DATA : std_logic_vector (31 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_S_DATA /= next_FSL_S_DATA) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_S_DATA="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_S_DATA);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_S_DATA);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_FSL_S_CONTROL(
			next_FSL_S_CONTROL : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_S_CONTROL /= next_FSL_S_CONTROL) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_S_CONTROL="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_S_CONTROL);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_S_CONTROL);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_FSL_S_EXISTS(
			next_FSL_S_EXISTS : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_S_EXISTS /= next_FSL_S_EXISTS) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_S_EXISTS="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_S_EXISTS);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_S_EXISTS);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		FSL_M_DATA <= transport std_logic_vector'("0000000000000000"); --0
		FSL_M_CONTROL <= transport '0';
		FSL_M_WRITE <= transport '0';
		FSL_S_READ <= transport '0';
		SYS_RESET <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		FSL_M_DATA <= transport std_logic_vector'("0000000000000001"); --1
		FSL_M_WRITE <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=200 ns
		FSL_M_DATA <= transport std_logic_vector'("0000000000000001"); --1
		-- --------------------
		WAIT FOR 100 ns; -- Time=300 ns
		FSL_M_DATA <= transport std_logic_vector'("0000000000000000"); --0
		FSL_M_WRITE <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=400 ns
		FSL_M_DATA <= transport std_logic_vector'("0000000000000000"); --0
		-- --------------------
		WAIT FOR 100 ns; -- Time=500 ns
		FSL_M_DATA <= transport std_logic_vector'("0000000000000000"); --0
		-- --------------------
		WAIT FOR 100 ns; -- Time=600 ns
		FSL_M_DATA <= transport std_logic_vector'("0000000000000000"); --0
		-- --------------------
		WAIT FOR 110 ns; -- Time=710 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			STD.TEXTIO.write(TX_OUT,string'("No errors or warnings"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			STD.TEXTIO.write(TX_OUT, TX_ERROR);
			STD.TEXTIO.write(TX_OUT, string'(
				" errors found in simulation"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION toplevel_cfg OF toplevel_tb IS
	FOR testbench_arch
	END FOR;
END toplevel_cfg;
